{********************************************}
{*****    PROZESS-UNIT  fr PC-XT/AT    *****}
{*****        unter TURBO-Pascal        *****}
{*****     Version 5.2 vom 01.09.94     *****}
{***** f. MODUL-BUS-System (nur Slot 1) *****}
{********************************************}
{*****  (C) Arbeitskreis Schulsoftware  *****}
{********************************************}
{*****    angepat an RS232-Adapter     *****}
{*****           bzw. RS-Box            *****}
{*****    auf 19200 Baud, n-Parity,     *****}
{*****        8 Bit, 2 Stopbit          *****}
{********************************************}
{*****    angepasst an DELPHI 32-BIT    *****}
{*****    Aufruf der ELEXS.DLL          *****}
{*****    OPENCOM, SENDBYTE, READBYTE   *****}
{*****    Fr COM1:19200,N,8,2          *****}
{********************************************}

UNIT PP_RS_E;


INTERFACE

TYPE  Bitmu_ = String[8];

   PROCEDURE DezAus (dwert :Byte);
   FUNCTION  DezEin :Byte;
   PROCEDURE ErwarteDez (dwert :Byte);
   PROCEDURE BinAus (bitm :Bitmu_);
   FUNCTION  BinEin :Bitmu_;
   FUNCTION  BinGleich (bitm :Bitmu_) :Boolean;
   PROCEDURE ErwarteBin (bitm :Bitmu_);
   PROCEDURE BitAus (bit :Byte; zeichen :Char);
   FUNCTION  BitEin (bit :Byte) :Char;
   FUNCTION  BitGleich (bit :Byte; zeichen :Char) :Boolean;
   PROCEDURE ErwarteBit (bit :Byte; zeichen :Char);
   PROCEDURE UAus (spannung :Real);
   FUNCTION  UEin (eingang,bereich :Byte) :Real;
   PROCEDURE AAus (dwert :Integer);
   FUNCTION  AEin (eingang :Byte) :Byte;
   PROCEDURE Warte (sekunden :Real);
   PROCEDURE Init;


IMPLEMENTATION

Uses {$IFDEF VER80} Dialogs, WinTypes, WinProcs;
     {$ELSE}
       {$IFDEF WIN32}
       Dialogs, Windows;
       {$ELSE}
       Crt, Dos;
       {$ENDIF}
     {$ENDIF}

Function OPENCOM(OpenString:PChar):Integer;stdcall; external 'ELEXS.DLL';
Procedure TIMEOUTS (TOut: Integer); stdcall; external 'ELEXS.DLL';
Procedure CLOSECOM(); stdcall; external 'ELEXS.DLL';
Procedure SENDBYTE (Dat: Integer); stdcall; external 'ELEXS.DLL';
Function READBYTE (): Integer; stdcall; external 'ELEXS.DLL';
Procedure DTR(d:WORD); stdcall; external 'ELEXS.DLL';
Procedure RTS(d:WORD); stdcall; external 'ELEXS.DLL';
Procedure TXD(d:WORD); stdcall; external 'ELEXS.DLL';
Function CTS:Integer; stdcall; external 'ELEXS.DLL';
Function DSR:Integer; stdcall; external 'ELEXS.:DLL';
Function RI:Integer; stdcall; external 'ELEXS.DLL';
Function DCD:Integer; stdcall; external 'ELEXS.DLL';
function INPUTS():Integer; stdcall; external 'ELEXS.DLL';
procedure TIMEINIT(); stdcall; external 'ELEXS.DLL';
function TIMEREAD(): Real; stdcall; external 'ELEXS.DLL';
//procedure DELAY(DelayTime: Real); stdcall; external 'ELEXS.DLL';
procedure REALTIME(); stdcall; external 'ELEXS.DLL';
procedure NORMALTIME(); stdcall; external 'ELEXS.DLL';


CONST zw_ho  : Array[0..7] of Byte = (1,2,4,8,16,32,64,128);

VAR   rs_ad  : Integer;
      status_: Byte;


PROCEDURE Sende (zeichen :Byte);
 BEGIN
  Sendbyte (zeichen);
 END;

FUNCTION Empfang :Byte;
 BEGIN
   Empfang:=Readbyte();
 END;

PROCEDURE DezAus (dwert :Byte);
 BEGIN
  Sende(81); Sende(dwert);
  status_:=dwert;
 END;

FUNCTION DezEin :Byte;
 BEGIN
  Sende(211); DezEin:=Empfang;
 END;

PROCEDURE ErwarteDez (dwert :Byte);
 BEGIN
  REPEAT UNTIL dwert=DezEin;
 END;

PROCEDURE BinAus (bitm :Bitmu_);
 VAR  i,stat :Byte;
 BEGIN
  stat:=status_;
  FOR i:=1 TO 8
  DO BEGIN
      CASE bitm[i]
      OF 'o','O' : stat:=stat And (255-zw_ho[8-i]);
         'i','I' : stat:=stat Or zw_ho[8-i];
         't','T' : stat:=stat XOr zw_ho[8-i];
         'x','X' : BEGIN {notwenig wegen ELSE} END;
      ELSE BEGIN
         {$IFDEF VER60}
            Writeln('* ungltiges Zeichen fr BINAUS !',#7);
            Halt;
         {$ELSE}
         {$ENDIF}
           END;
      END;
     END;
  DezAus(stat);
 END;

FUNCTION BinEin :Bitmu_;
 VAR  dwert,i :Byte;
      bitm :Bitmu_;
 BEGIN
  dwert:=DezEin;
  bitm:='';
  FOR i:=0 TO 7
  DO IF (dwert And zw_ho[i]) > 0
     THEN bitm:='I'+bitm
     ELSE bitm:='O'+bitm;
  BinEin:=bitm;
 END;

FUNCTION BinGleich (bitm :Bitmu_) :Boolean;
 VAR  dwert,vwert,i :Byte;
 BEGIN
  dwert:=DezEin; vwert:=0;
  FOR i:=1 TO 8
  DO CASE bitm[i]
     OF 'x','X' : vwert:=vwert+(dwert And zw_ho[8-i]);
        'i','I' : vwert:=vwert+zw_ho[8-i];
        'o','O' : BEGIN {notwendig wegen ELSE} END;
     ELSE BEGIN
           Writeln('* ungltiges Zeichen fr BINGLEICH !',#7);
           Halt;
          END;
     END;
  BinGleich:=(dwert=vwert);
 END;

PROCEDURE ErwarteBin (bitm :Bitmu_);
 VAR  dwert,vwert,awert,i :Byte;
 BEGIN
  awert:=DezEin;
  dwert:=0; vwert:=255;
  FOR i:=1 TO 8
  DO CASE bitm[i]
     OF 't','T' : IF (awert And zw_ho[8-i]) = 0
                  THEN dwert:=dwert+zw_ho[8-i];
        'x','X' : vwert:=vwert-zw_ho[8-i];
        'i','I' : dwert:=dwert+zw_ho[8-i];
        'o','O' : BEGIN {notwendig wegen ELSE} END;
     ELSE BEGIN
           Writeln('* ungltiges Zeichen fr ERWARTEBIN !',#7);
           Halt;
          END;
     END;
  REPEAT UNTIL (DezEin And vwert) = dwert;
 END;

PROCEDURE BitAus (bit :Byte; zeichen :Char);
 VAR  stat :Byte;
 BEGIN
  stat:=status_;
  CASE zeichen
  OF 'o','O' : stat:=stat And (255-zw_ho[bit]);
     'i','I' : stat:=stat Or zw_ho[bit];
     't','T' : stat:=stat XOr zw_ho[bit];
  ELSE BEGIN
        Writeln('* ungltiges Zeichen fr BITAUS !',#7);
        Halt;
       END;
  END;
  DezAus(stat);
 END;

FUNCTION BitEin (bit :Byte) :Char;
 BEGIN
  IF (DezEin And zw_ho[bit]) > 0
  THEN BitEin:='I'
  ELSE BitEin:='O';
 END;

FUNCTION BitGleich (bit :Byte; zeichen :Char) :Boolean;
 BEGIN
  CASE zeichen
  OF 'o','O' : BitGleich:= ((DezEin And zw_ho[bit]) = 0);
     'i','I' : BitGleich:= ((DezEin And zw_ho[bit]) > 0);
  ELSE BEGIN
        Writeln('* ungltiges Zeichen fr BITGLEICH !',#7);
        Halt;
       END;
  END;
 END;

PROCEDURE ErwarteBit (bit :Byte; zeichen :Char);
 VAR  dwert :Byte;
 BEGIN
  dwert:=DezEin And zw_ho[bit];
  CASE zeichen
  OF 't','T' : dwert:=dwert XOr zw_ho[bit];
     'i','I' : dwert:=zw_ho[bit];
     'o','O' : dwert:=0;
  ELSE BEGIN
        Writeln('* ungltiges Zeichen fr ERWARTEBIT !',#7);
        Halt;
       END;
  END;
  REPEAT UNTIL (DezEin And zw_ho[bit]) = dwert;
 END;

PROCEDURE UAus (spannung :Real);
 BEGIN
  IF spannung<0
  THEN BEGIN
        Sende(81); Sende(Round(spannung*25+127));
       END
  ELSE BEGIN
        Sende(83); Sende(Round(spannung*50));
       END;
 END;

FUNCTION UEin (eingang,bereich :Byte) :Real;
 VAR  dwert :Byte;
 BEGIN
  Sende(207+2*eingang); dwert:=Empfang;   {'dummy'}
  Sende(207+2*eingang); dwert:=Empfang;
  CASE bereich
  OF   1 : UEin:=dwert/1000;
       2 : UEin:=dwert/100;
       3 : UEin:=dwert/10;
       4 : UEin:=(dwert-127)/1000;
       5 : UEin:=(dwert-127)/100;
       6 : UEin:=(dwert-127)/10;
  ELSE BEGIN
        Writeln('* ungltiger Bereich fr UEIN !',#7);
        Halt;
       END;
  END;
 END;

PROCEDURE AAus (dwert :Integer);
 BEGIN
  IF dwert<0
  THEN BEGIN
        Sende(81); Sende(127+(dwert Div 2));
       END
  ELSE BEGIN
        Sende(83); Sende(dwert);
       END;
 END;

FUNCTION AEin (eingang :Byte) :Byte;
 VAR  dwert,i :Byte;
 BEGIN
  Sende(176);    { alle DE/ST auf Low }
  Sende(210); dwert:=Empfang;   {'dummy'}
  Sende(210); dwert:=Empfang;
  CASE eingang
  OF   1 : BEGIN
            Sende(210); AEin:=Empfang;
           END;
       2 : AEin:=dwert;
  ELSE BEGIN
        Writeln('* ungltiger Eingang fr AEIN !',#7);
        Halt;
       END;
  END;
END;

Procedure DELAY(ms : LongInt);
Var TickCount : LongInt;
    M         : TMsg;
Begin
  TickCount := GetTickCount;
  While GetTickCount - TickCount < ms do
  If PeekMessage(M,0,0,0,pm_Remove) then Begin
    TranslateMessage(M); DispatchMessage(M);
  End;
End;

PROCEDURE Warte (sekunden :Real);
 BEGIN
   Delay(Round(sekunden*1000));
 END;

PROCEDURE Init;
 VAR  b :Byte;
 BEGIN
  Opencom ('COM1:19200,N,8,2');
  b:=DezEin;          { Test }
  DezAus(0);
  Sende(176);         { alle DE/ST auf Low }
 END;

 END.

{===========================================================================}

