UNIT ROB1_S;

INTERFACE

VAR   z_pos,r_pos  :Integer;      { Position Hhe,Winkel }
      sm_1,sm_2    :Byte;         { Laufvariablen fr Motorstellwerte }
      s_bits       :Byte;         { Ausgabewert fr Bits 4-7 }
    { Die Zuweisung fr folgende Variablen erfolgt in HARD_INIT ! }
      b_adr        :Integer;      { Adresse der seriellen Schnittstelle }
      verz_1       :Byte;         { kleiner Verzgerungswert }
      verz_2       :Byte;         { groer Verzgerungswert }
      z_fak        :Real;         { Streckungsfaktor in vertikaler Richtung }
      r_fak        :Real;         { Streckungsfaktor in Drehrichtung }

CONST  motor_1  :Array[1..4]
                 Of Byte = (1,3,2,0);  { Werte fr Motorstellungen }
       motor_2  :Array[1..4]
                 Of Byte = (4,12,8,0);

 PROCEDURE Ausgaenge (wert :Byte);
 FUNCTION  Eingaenge :Byte;
 PROCEDURE Hard_Init;
 PROCEDURE Bewege_S (zs,rs :Integer);
 PROCEDURE Hebe_S (zs :Integer);
 PROCEDURE Drehe_S (rs :Integer);
 PROCEDURE Position_S (zs,rs :Integer);
 PROCEDURE Hoehe_S (zs :Integer);
 PROCEDURE Winkel_S (rs :Integer);
 PROCEDURE Ausgangspunkt;
 PROCEDURE Bewege (z,r :Real);
 PROCEDURE Hebe (z :Real);
 PROCEDURE Drehe (r :Real);
 PROCEDURE Position (z,r :Real);
 PROCEDURE Hoehe (z :Real);
 PROCEDURE Winkel (r :Real);

 PROCEDURE Magnet_ein;
 PROCEDURE Magnet_aus;

IMPLEMENTATION

Uses Dialogs, Windows;

Function OPENCOM(OpenString:PChar):Integer;stdcall; external 'ELEXS.DLL';
Procedure TIMEOUTS (TOut: Integer); stdcall; external 'ELEXS.DLL';
Procedure CLOSECOM(); stdcall; external 'ELEXS.DLL';
Procedure SENDBYTE (Dat: Integer); stdcall; external 'ELEXS.DLL';
Function READBYTE (): Integer; stdcall; external 'ELEXS.DLL';
Procedure DTR(d:WORD); stdcall; external 'ELEXS.DLL';
Procedure RTS(d:WORD); stdcall; external 'ELEXS.DLL';
Procedure TXD(d:WORD); stdcall; external 'ELEXS.DLL';
Function CTS:Integer; stdcall; external 'ELEXS.DLL';
Function DSR:Integer; stdcall; external 'ELEXS.:DLL';
Function RI:Integer; stdcall; external 'ELEXS.DLL';
Function DCD:Integer; stdcall; external 'ELEXS.DLL';
function INPUTS():Integer; stdcall; external 'ELEXS.DLL';
procedure TIMEINIT(); stdcall; external 'ELEXS.DLL';
function TIMEREAD(): Real; stdcall; external 'ELEXS.DLL';
//procedure DELAY(DelayTime: Real); stdcall; external 'ELEXS.DLL';
procedure REALTIME(); stdcall; external 'ELEXS.DLL';
procedure NORMALTIME(); stdcall; external 'ELEXS.DLL';

PROCEDURE Sende (zeichen :Byte);
 BEGIN
   Sendbyte (zeichen);
 END;

FUNCTION Empfang :Byte;
 BEGIN
   Empfang:=Readbyte();
 END;

PROCEDURE Ausgaenge (wert :Byte);            { nur sinnvoll fr Bit 4-7 }
 BEGIN
  s_bits:=wert And 240;                      { Bit 0-3 werden unterdrckt }
  Sende(81);                                 { Leitungen als Ausgnge }
  Sende(motor_1[sm_1]+motor_2[sm_2]+s_bits); { Ausgabe des Wertes }
 END;

FUNCTION Eingaenge :Byte;
 BEGIN
  Sende(211);                  { Leitungen als Eingnge }
  Eingaenge:=Empfang;          { Wert der Eingangsleitungen }
 END;

PROCEDURE Hard_Init;
 VAR  b :Byte;
 BEGIN
 { b_adr:=$02F8; { Adresse d. RS232-Schnittstelle: $03F8 = COM1, $02F8 = COM2
  WritePort(b_adr+4,$03);    { DTR=1 ; RTS=1
  WritePort(b_adr+3,$80);    { Anwahl Teilerfaktor-LSB , dann MSB
  WritePort(b_adr+0,$06);    { $03        $0C       $30       $C0      $80
  WritePort(b_adr+1,$00);    { $00=38400, $00=9600, $00=2400, $00=600, $01=300
  WritePort(b_adr+3,$07);    { 8-Bit, n-Parity, 2 Stopbits
  WritePort(b_adr+1,$00);    { Freigabe: Interrupts
  b:=ReadPort(b_adr);        { Eingabepuffer leer }

  Opencom ('COM1:19200,N,8,2');
  Ausgaenge(0);
  b:=Eingaenge;          { Test }
  Sende(176);         { alle DE/ST auf Low }

  verz_1:= 10;           { kleiner Verzgerungswert }
  verz_2:= 20;           { groer Verzgerungswert }
  z_fak:= 5.0;           { Streckungsfaktor in vertikaler Richtung }
  r_fak:= 4.0;           { Streckungsfaktor in Drehrichtung }
  sm_1:=1; sm_2:=1;      { Laufvariable fr beide Motoren auf Startwert }
  z_pos:=Round(100*z_fak);
  r_pos:=0;              { Vordefinition der absoluten Position }
  Ausgaenge(0);          { Bits 4-7 hier zu Beginn auf 0 }
  b:=Eingaenge;          { Probeabfrage }
 END;

Procedure DELAY(ms : LongInt);
Var TickCount : LongInt;
    M         : TMsg;
Begin
  TickCount := GetTickCount;
  While GetTickCount - TickCount < ms do
  If PeekMessage(M,0,0,0,pm_Remove) then Begin
    TranslateMessage(M); DispatchMessage(M);
  End;
End;

{--------------------------------------------}

PROCEDURE Bewege_S (zs,rs :Integer);       { relativ in Schritte }
 VAR  Teile,Verz,
      Z_Abs,R_Abs,
      Z_Step,R_Step,
      Z_Inc,R_Inc    :Integer;
      Tausch         :Boolean;

  FUNCTION Sgn (wert :Integer) :Integer;
   BEGIN
    IF wert>0
    THEN Sgn:=1
    ELSE BEGIN
          Sgn:=-1;
          IF wert=0 THEN Sgn:=0;
         END;
   END;

   PROCEDURE Weg;
    BEGIN
     z_pos:=z_pos+zs; r_pos:=r_pos+rs;
     sm_1:=sm_1+zs; sm_2:=sm_2-rs;  { '-' wegen Wickelrichtung }
     IF sm_1>4 THEN sm_1:=1; IF sm_1<1 THEN sm_1:=4;
     IF sm_2>4 THEN sm_2:=1; IF sm_2<1 THEN sm_2:=4;
     Sende(81); Sende(motor_1[sm_1]+motor_2[sm_2]+s_bits);
     Delay(Verz); IF Verz>verz_1 THEN Verz:=Pred(Verz);
    END;

   PROCEDURE Lauf;
    VAR  Schritte :Integer;
    BEGIN
     Verz:=verz_2;
     FOR Schritte:=1 TO Z_Abs
     DO BEGIN
         zs:=0; rs:=0;
         IF Teile >=0
         THEN BEGIN
               IF Tausch THEN zs:=Z_Step ELSE rs:=R_Step;
               Teile:=Teile-R_Inc;
              END;
         IF Tausch THEN rs:=R_Step ELSE zs:=Z_Step;
         Teile:=Teile+Z_Inc;
         Weg;
        END;
    END;

 BEGIN   { Bewege_S }
  Z_Abs:=Abs(zs); R_Abs:=Abs(rs);
  Z_Step:=Sgn(zs); R_Step:=Sgn(rs);
  IF Z_Abs < R_Abs
  THEN BEGIN
        Teile:=Z_Abs; Z_Abs:=R_Abs;
        R_Abs:=Teile; Tausch:=true;
       END
  ELSE Tausch:=false;
  Teile:=2*R_Abs-Z_Abs;
  Z_Inc:=2*R_Abs; R_Inc:=2*Z_Abs;
  Lauf;
 END;

PROCEDURE Hebe_S (zs :Integer);           { relativ in Schritte }
 BEGIN
  Bewege_S(zs,0);
 END;

PROCEDURE Drehe_S (rs :Integer);          { relativ in Schritte }
 BEGIN
  Bewege_S(0,rs);
 END;

PROCEDURE Position_S (zs,rs :Integer);    { absolut in Schritte }
 BEGIN
  Bewege_S(zs-z_pos,rs-r_pos);
 END;

PROCEDURE Hoehe_S (zs :Integer);          { absolut in Schritte }
 BEGIN
  Bewege_S(zs-z_pos,0);
 END;

PROCEDURE Winkel_S (rs :Integer);         { absolut in Schritte }
 BEGIN
  Bewege_S(0,rs-r_pos);
 END;

PROCEDURE Ausgangspunkt;
 VAR  schalter :Byte;
 BEGIN
  REPEAT
   schalter:=Eingaenge And 192;        { Wert der Endschalter }
   CASE schalter
   OF   0: BEGIN sm_1:=Succ(sm_1); sm_2:=Succ(sm_2); END;
       64: sm_1:=Succ(sm_1);  { Endschalter in Drehrichtung }
      128: sm_2:=Succ(sm_2);  { Endschalter in vertikaler Richtung }
      END;
   IF sm_1>4 THEN sm_1:=1; IF sm_1<1 THEN sm_1:=4;
   IF sm_2>4 THEN sm_2:=1; IF sm_2<1 THEN sm_2:=4;
   Sende(81); Sende(motor_1[sm_1]+motor_2[sm_2]+s_bits);
   Delay(verz_1);
  UNTIL schalter=192;
  Bewege_S(-10,10);
  z_pos:=Round(100*z_fak); r_pos:=0;   { Ausgangsposition }
 END;

PROCEDURE Bewege (z,r :Real);       { relativ in Millimeter bzw. Grad }
 BEGIN
  Bewege_S(Round(z*z_fak),Round(r*r_fak));
 END;

PROCEDURE Hebe (z :Real);           { relativ in Millimeter bzw. Grad }
 BEGIN
  Bewege_S(Round(z*z_fak),0);
 END;

PROCEDURE Drehe (r :Real);          { relativ in Millimeter bzw. Grad }
 BEGIN
  Bewege_S(0,Round(r*r_fak));
 END;

PROCEDURE Position (z,r :Real);     { absolut in Millimeter bzw. Grad }
 BEGIN
  Bewege_S(Round(z*z_fak)-z_pos,Round(r*r_fak)-r_pos);
 END;

PROCEDURE Hoehe (z :Real);          { absolut in Millimeter bzw. Grad }
 BEGIN
  Bewege_S(Round(z*z_fak)-z_pos,0);
 END;

PROCEDURE Winkel (r :Real);         { absolut in Millimeter bzw. Grad }
 BEGIN
  Bewege_S(0,Round(r*r_fak)-r_pos);
 END;

PROCEDURE Magnet_ein;
 BEGIN
  Delay(50);
  Ausgaenge((s_bits And 223) Or 16);
  Delay(50);
 END;

PROCEDURE Magnet_aus;
 BEGIN
  Ausgaenge((s_bits And 239) Or 32);   { wegen Restmagnetismus }
  Delay(50);
  Ausgaenge(s_bits And 207);
  Delay(250);
 END;


END. 

{==========================================================================}


